--- golang-1.10/src/syscall/zsyscall_solaris_amd64.go	2018-02-16 09:12:19.000000000 +0000
+++ golang-1.10/src/syscall/zsyscall_solaris_amd64.go.1	2018-05-01 03:21:18.224140250 +0000
@@ -21,6 +21,7 @@
 //go:cgo_import_dynamic libc_Chroot chroot "libc.so"
 //go:cgo_import_dynamic libc_Close close "libc.so"
 //go:cgo_import_dynamic libc_Dup dup "libc.so"
+//go:cgo_import_dynamic libc_Dup2 dup2 "libc.so"
 //go:cgo_import_dynamic libc_Fchdir fchdir "libc.so"
 //go:cgo_import_dynamic libc_Fchmod fchmod "libc.so"
 //go:cgo_import_dynamic libc_Fchown fchown "libc.so"
@@ -105,6 +106,7 @@
 //go:linkname libc_Chroot libc_Chroot
 //go:linkname libc_Close libc_Close
 //go:linkname libc_Dup libc_Dup
+//go:linkname libc_Dup2 libc_Dup2
 //go:linkname libc_Fchdir libc_Fchdir
 //go:linkname libc_Fchmod libc_Fchmod
 //go:linkname libc_Fchown libc_Fchown
@@ -192,6 +194,7 @@
 	libc_Chroot,
 	libc_Close,
 	libc_Dup,
+	libc_Dup2,
 	libc_Fchdir,
 	libc_Fchmod,
 	libc_Fchown,
@@ -410,6 +413,14 @@
 	return
 }
 
+func Dup2(oldfd int, newfd int) (err error) {
+        _, _, e1 := sysvicall6(uintptr(unsafe.Pointer(&libc_Dup2)), 2, uintptr(oldfd), uintptr(newfd), 0, 0, 0, 0)
+        if e1 != 0 {
+                err = errnoErr(e1)
+        }
+        return
+}
+
 func Fchdir(fd int) (err error) {
 	_, _, e1 := sysvicall6(uintptr(unsafe.Pointer(&libc_Fchdir)), 1, uintptr(fd), 0, 0, 0, 0, 0)
 	if e1 != 0 {
